<template>
  <div class="sidebar" :class="{ expand: expand }">
    <div class="d-flex flex-wrap">
      <TitleIcon id="title" :showTitle="expand" />
      <span class="btn-expand" @click="$emit('expandClick')">
        <i class="fas fa-bars"></i>
      </span>
    </div>
    <div class="user">
      <img class="avatar" :src="profileImgUrl" />
      <div class="name">{{ me?.displayName }}</div>
    </div>
    <ul>
      <li>
        <router-link to="/Profile">
          📊
          <span>&nbsp;Overview</span>
        </router-link>
      </li>
      <li>
        <router-link to="/Tips">
          🎁
          <span>&nbsp;Tips</span>
        </router-link>
      </li>
      <li>
        <router-link to="/Account">
          🤖
          <span>&nbsp;Account</span>
        </router-link>
      </li>
      <li>
        <router-link to="/Withdraw">
          💸
          <span>&nbsp;Withdraw</span>
        </router-link>
      </li>

      <li @click="onClickLogout" class="logout a">
        🚀
        <span>&nbsp;Logout</span>
      </li>
    </ul>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import TitleIcon from "./TitleIcon";

export default {
  name: "SideBarProfile",
  components: {
    TitleIcon,
  },
  props: {
    expand: {
      type: Boolean,
      default: true,
    },
  },
  methods: {
    ...mapActions(["logoutMe"]),
    onClickLogout() {
      this.logoutMe().then((res) => {
        if (res) this.$router.push({ name: "Home" });
      });
    },
  },
  computed: {
    me() {
      return this.$store.state.users.me;
    },
    profileImgUrl() {
      return process.env.VUE_APP_API_URL + this.$store.state.users?.me?.imgUrl;
    },
  },
};
</script>

<style lang="scss" scoped>
.sidebar {
  background-color: $bg-color-dark;
  padding: 5px 8px;
  align-self: start;
}

#title {
  font-size: 1.8em;
  margin: 7px 10px 8px 10px;
}

.btn-expand {
  display: none;
  text-align: center;
  width: 100%;
  margin: auto;

  cursor: pointer;
  font-size: 20px;
  opacity: 0.8;

  &:hover {
    opacity: 1;
  }
}

.expand .btn-expand {
  margin: 10px 14px 0 auto;
  width: auto;
}

.user {
  text-align: center;
  margin-bottom: 1em;
  display: none;

  .avatar {
    color: black;
    background-color: white;
    border-radius: 50%;
    margin: 0 auto;
    padding: 5px;
    margin-bottom: 0.3em;
  }
  .name {
    font-family: "Rajdhani", sans-serif;
    font-size: 1.5em;
    font-weight: 500;
  }
}

.expand .user {
  display: block;

  .avatar {
    height: 7em;
    width: 7em;
  }
  .name {
    display: block;
  }
}

ul {
  margin-top: 3em;
  list-style: none;
  padding: 0;
  font-family: Rajdhani, sans-serif;
}

ul > li > a,
ul > li.a {
  color: white;
  font-size: 1.2em;
  text-align: center;
  padding: 10px 0;
  cursor: pointer;
  border-radius: 15px;
  opacity: 0.8;
  display: block;
  height: 100%;
  width: 100%;
  text-decoration: none;

  &.router-link-exact-active {
    background-color: #484848;
    opacity: 1;
  }

  &:hover {
    color: white;
    opacity: 1;
  }

  span {
    display: none;
  }
}

.expand ul > li > a,
.expand ul > li.a {
  margin-top: 0;
  text-align: start;
  padding: 10px 20px;

  span {
    display: initial;
  }
}

.logout {
  margin-top: 2em !important;
  font-size: 1.1em !important;
}
</style>